Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 455540 - named init script doesn't wait for server terminaton
Summary: named init script doesn't wait for server terminaton
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: bind
Version: 4.8
Hardware: All
OS: Linux
urgent
high
Target Milestone: rc
: ---
Assignee: Adam Tkac
QA Contact: Martin Cermak
URL:
Whiteboard:
Depends On:
Blocks: 455564 502852 552576
TreeView+ depends on / blocked
 
Reported: 2008-07-15 22:46 UTC by Kevin Graham
Modified: 2016-06-17 21:09 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
The named init script did not wait for proper named termination before attempting to restart named, which, when the name server was under moderate or high load, could have caused a failure to start. With this update, the named init script waits for named termination before attempting to restart the name server.
Clone Of:
: 502852 (view as bug list)
Environment:
Last Closed: 2011-02-16 14:03:40 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2011:0223 normal SHIPPED_LIVE bind bug fix update 2011-02-15 16:35:29 UTC

Description Kevin Graham 2008-07-15 22:46:18 UTC
Description of problem:

It looks like this is was likely addressed in bug 426382, however there is no
fix incorporated into RH 4 (and presumably 5, though I have not verified). If
named is stopped via rndc, it won't exit immediately and as such the 'start' of
a 'restart' will be attempted before the prior instance had completed shutdown.

Version-Release number of selected component (if applicable):

bind-9.2.4-28.0.1.el4

How reproducible:

Get a reasonably loaded bind instance going (~200mb of heap in this case) and
execute a restart via the stock init script. Most of the time the start will
fail due to the daemon still exiting.

A fix as trivial as:

128a129,131
>               while pidofproc named >/dev/null 2>&1; do
>                       sleep 1
>               done
158,159d160
< # wait a couple of seconds for the named to finish closing down
<       sleep 2

...resolves the issue.

Comment 1 Adam Tkac 2008-07-16 08:52:56 UTC
Right you are. Thanks for your report

Comment 2 RHEL Product and Program Management 2008-10-31 16:38:28 UTC
This request was evaluated by Red Hat Product Management for
inclusion, but this component is not scheduled to be updated in
the current Red Hat Enterprise Linux release. If you would like
this request to be reviewed for the next minor release, ask your
support representative to set the next rhel-x.y flag to "?".

Comment 3 Kevin Graham 2009-01-30 21:32:26 UTC
re comment 2 -- Applying RHSA-2009:0020 resulted in yet another service outage due to this bug. Could Red Hat Product Management perhaps re-consider the implications of this 3 line patch?

Comment 14 Martin Prpič 2010-06-11 12:33:29 UTC
Technical note added. If any revisions are required, please edit the "Technical Notes" field
accordingly. All revisions will be proofread by the Engineering Content Services team.

New Contents:
* the named init script did not wait for proper named termination before attempting to restart named, which, when the name server was under moderate or high load, could have caused a failure to start. With this update, the named init script waits for named termination before attempting to restart the name server.

Comment 15 Douglas Silas 2010-06-14 07:07:28 UTC
Technical note updated. If any revisions are required, please edit the "Technical Notes" field
accordingly. All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1 +1 @@
-* the named init script did not wait for proper named termination before attempting to restart named, which, when the name server was under moderate or high load, could have caused a failure to start. With this update, the named init script waits for named termination before attempting to restart the name server.+The named init script did not wait for proper named termination before attempting to restart named, which, when the name server was under moderate or high load, could have caused a failure to start. With this update, the named init script waits for named termination before attempting to restart the name server.

Comment 17 errata-xmlrpc 2011-02-16 14:03:40 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0223.html


Note You need to log in before you can comment on or make changes to this bug.